unit Sample4_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, _MnOglCanvas, _MNOglTools, _MNComTypes, _MNdevice,
  _MNOglExTools, StdCtrls;

type
  TForm1 = class(TForm)
    MNOglControl1: TMNOglControl;
    Splitter1: TSplitter;
    Panel1: TPanel;
    MnOglCanvas1: TMnOglCanvas;
    MNOglScene1: TMNOglScene;
    MNOglPlane1: TMNOglPlane;
    MNOglPlane2: TMNOglPlane;
    MNOglScene2: TMNOglScene;
    MNOglShape1: TMNOglShape;
    MNOglNav1: TMNOglNav;
    MNOglLight1: TMNOglLight;
    RadioGroup1: TRadioGroup;
    procedure MNOglShape1Play(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
  _MNmath, _MNxyz, _MNxyarrays;

{$R *.DFM}

procedure TForm1.MNOglShape1Play(Sender: TObject);
VAR
  L : TXYZArray;
  _Save : TAttributesKind;
  Mat : TMaterialKind;
begin
  //
  // Part One
  //
  ArrayInit(L, SizeOf (TXYZ), 5); // define type of structure
  ArraySetCount (@L,4);           // order mem

  _save:=MnOglCanvas1.AttributesKind;  // rescue current Attributes
  Mat := MNOglCanvas1.Attributes.Material.Kind;  // fill Mat with current settings
  Mat.EMISSION := clRed;  // set red color to EMISSION field
  MNOglCanvas1.Attributes.Material.kind := Mat;  // activate Mat settings

  with L do begin                 // the container for the points
    Items[0] := NewPt (0,0,0);    // first point
    Items[1] := NewPt (0,3,0);    // second point
    Items[2] := NewPt (3,3,0);    // third point
    Items[3] := NewPt (3,0,0);    // fourth point
    MnOglCanvas1.Polyline3d(L);   // play the data
  end;

  with L do begin
    Items[0] := NewPt (0,0,0);
    Items[1] := NewPt (0,3,0);
    Items[2] := NewPt (0,3,3);
    Items[3] := NewPt (0,0,3);
    MnOglCanvas1.Polyline3d(L);
  end;

  with L do begin
    Items[0] := NewPt (3,0,0);
    Items[1] := NewPt (0,0,0);
    Items[2] := NewPt (0,0,3);
    Items[3] := NewPt (3,0,3);
    MnOglCanvas1.Polyline3d(L);
  end;

  with L do begin
    Items[0] := NewPt (0,0,3);
    Items[1] := NewPt (0,3,3);
    Items[2] := NewPt (3,3,3);
    Items[3] := NewPt (3,0,3);
    MnOglCanvas1.Polyline3d(L);
  end;

  //
  // Part Two
  //
  Mat.EMISSION := clNavy;
  MNOglCanvas1.Attributes.Material.kind := Mat;
  with L do begin
    Items[0] := NewPt (0,3,0);
    Items[1] := NewPt (3,3,0);
    Items[2] := NewPt (3,3,3);
    Items[3] := NewPt (0,3,3);
    MnOglCanvas1.Polyline3d(L);
  end;
  with L do begin
    Items[0] := NewPt (3,3,0);
    Items[1] := NewPt (3,0,0);
    Items[2] := NewPt (3,0,3);
    Items[3] := NewPt (3,3,3);
    MnOglCanvas1.Polyline3d(L);
  end;

  MnOglCanvas1.AttributesKind:=_save; // set rescued Attributes
  ArrayClear(L); // free mem 
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  //
  MNOglScene1.Visible := (RadioGroup1.itemindex = 0);
  MNOglScene2.Visible := NOT MNOglScene1.Visible; 
end;

end.
